package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

BA.applicationContext.stopService(new android.content.Intent(BA.applicationContext, starter.class));
}
public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblyellow = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblgreen = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblred = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblblue = null;
public static int _windex = 0;
public static int _wcterror = 0;
public static int[] _wtunesapp = null;
public static int _wtune = 0;
public static int _wtimewait = 0;
public static int[] _wtabcoloroff = null;
public static int[] _wtabcoloron = null;
public anywheresoftware.b4a.objects.LabelWrapper _wkey = null;
public anywheresoftware.b4a.audio.Beeper _wbeeper = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnstart = null;
public b4a.example.starter _starter = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
int _wgap = 0;
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="Activity.LoadLayout(\"Play\")";
mostCurrent._activity.LoadLayout("Play",mostCurrent.activityBA);
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="Dim wGap As Int = (Activity.Width - (2 * lblYello";
_wgap = (int) ((mostCurrent._activity.getWidth()-(2*mostCurrent._lblyellow.getWidth()))/(double)3);
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="lblYellow.left = wGap";
mostCurrent._lblyellow.setLeft(_wgap);
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="lblYellow.Top = wGap";
mostCurrent._lblyellow.setTop(_wgap);
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="lblGreen.left = lblYellow.Width + (2 * wGap)";
mostCurrent._lblgreen.setLeft((int) (mostCurrent._lblyellow.getWidth()+(2*_wgap)));
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="lblGreen.Top = lblYellow.top";
mostCurrent._lblgreen.setTop(mostCurrent._lblyellow.getTop());
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="lblRed.left = lblYellow.Left";
mostCurrent._lblred.setLeft(mostCurrent._lblyellow.getLeft());
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="lblRed.Top = lblYellow.height + (2 * wGap)";
mostCurrent._lblred.setTop((int) (mostCurrent._lblyellow.getHeight()+(2*_wgap)));
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="lblBlue.left = lblGreen.left";
mostCurrent._lblblue.setLeft(mostCurrent._lblgreen.getLeft());
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="lblBlue.Top = lblRed.top";
mostCurrent._lblblue.setTop(mostCurrent._lblred.getTop());
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
public static void  _appplaytunes() throws Exception{
ResumableSub_APPplayTunes rsub = new ResumableSub_APPplayTunes(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_APPplayTunes extends BA.ResumableSub {
public ResumableSub_APPplayTunes(b4a.example.main parent) {
this.parent = parent;
}
b4a.example.main parent;
int _i = 0;
int step2;
int limit2;

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="main";
Debug.delegate(mostCurrent.activityBA, "appplaytunes", null);
if (true) return;
    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
RDebugUtils.currentLine=3670017;
 //BA.debugLineNum = 3670017;BA.debugLine="Dim i As Int";
_i = 0;
RDebugUtils.currentLine=3670018;
 //BA.debugLineNum = 3670018;BA.debugLine="For i = 0 To wIndex";
if (true) break;

case 1:
//for
this.state = 14;
step2 = 1;
limit2 = parent._windex;
_i = (int) (0) ;
this.state = 15;
if (true) break;

case 15:
//C
this.state = 14;
if ((step2 > 0 && _i <= limit2) || (step2 < 0 && _i >= limit2)) this.state = 3;
if (true) break;

case 16:
//C
this.state = 15;
_i = ((int)(0 + _i + step2)) ;
if (true) break;

case 3:
//C
this.state = 4;
RDebugUtils.currentLine=3670019;
 //BA.debugLineNum = 3670019;BA.debugLine="wTune = wTunesApp(i)";
parent._wtune = parent._wtunesapp[_i];
RDebugUtils.currentLine=3670020;
 //BA.debugLineNum = 3670020;BA.debugLine="Log(\"APPplayTunes: Index: \" & wIndex & \" wTune:";
anywheresoftware.b4a.keywords.Common.Log("APPplayTunes: Index: "+BA.NumberToString(parent._windex)+" wTune: "+BA.NumberToString(parent._wtune));
RDebugUtils.currentLine=3670021;
 //BA.debugLineNum = 3670021;BA.debugLine="Select wTune";
if (true) break;

case 4:
//select
this.state = 13;
switch (parent._wtune) {
case 0: {
this.state = 6;
if (true) break;
}
case 1: {
this.state = 8;
if (true) break;
}
case 2: {
this.state = 10;
if (true) break;
}
case 3: {
this.state = 12;
if (true) break;
}
}
if (true) break;

case 6:
//C
this.state = 13;
RDebugUtils.currentLine=3670023;
 //BA.debugLineNum = 3670023;BA.debugLine="lblYellow.Color = wTabColorON(wTune)		' Light";
parent.mostCurrent._lblyellow.setColor(parent._wtabcoloron[parent._wtune]);
RDebugUtils.currentLine=3670024;
 //BA.debugLineNum = 3670024;BA.debugLine="Sleep(wTimeWait)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,parent._wtimewait);
this.state = 17;
return;
case 17:
//C
this.state = 13;
;
RDebugUtils.currentLine=3670025;
 //BA.debugLineNum = 3670025;BA.debugLine="PlayTune(wTune)";
_playtune(parent._wtune);
RDebugUtils.currentLine=3670026;
 //BA.debugLineNum = 3670026;BA.debugLine="lblYellow.Color = wTabColorOFF(wTune)		' Dark";
parent.mostCurrent._lblyellow.setColor(parent._wtabcoloroff[parent._wtune]);
 if (true) break;

case 8:
//C
this.state = 13;
RDebugUtils.currentLine=3670028;
 //BA.debugLineNum = 3670028;BA.debugLine="lblGreen.Color = wTabColorON(wTune)			' Light";
parent.mostCurrent._lblgreen.setColor(parent._wtabcoloron[parent._wtune]);
RDebugUtils.currentLine=3670029;
 //BA.debugLineNum = 3670029;BA.debugLine="Sleep(wTimeWait)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,parent._wtimewait);
this.state = 18;
return;
case 18:
//C
this.state = 13;
;
RDebugUtils.currentLine=3670030;
 //BA.debugLineNum = 3670030;BA.debugLine="PlayTune(wTune)";
_playtune(parent._wtune);
RDebugUtils.currentLine=3670031;
 //BA.debugLineNum = 3670031;BA.debugLine="lblGreen.Color = wTabColorOFF(wTune)		' Dark C";
parent.mostCurrent._lblgreen.setColor(parent._wtabcoloroff[parent._wtune]);
 if (true) break;

case 10:
//C
this.state = 13;
RDebugUtils.currentLine=3670033;
 //BA.debugLineNum = 3670033;BA.debugLine="lblRed.Color = wTabColorON(wTune)			' Light Co";
parent.mostCurrent._lblred.setColor(parent._wtabcoloron[parent._wtune]);
RDebugUtils.currentLine=3670034;
 //BA.debugLineNum = 3670034;BA.debugLine="Sleep(wTimeWait)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,parent._wtimewait);
this.state = 19;
return;
case 19:
//C
this.state = 13;
;
RDebugUtils.currentLine=3670035;
 //BA.debugLineNum = 3670035;BA.debugLine="PlayTune(wTune)";
_playtune(parent._wtune);
RDebugUtils.currentLine=3670036;
 //BA.debugLineNum = 3670036;BA.debugLine="lblRed.Color = wTabColorOFF(wTune)			' Dark Co";
parent.mostCurrent._lblred.setColor(parent._wtabcoloroff[parent._wtune]);
 if (true) break;

case 12:
//C
this.state = 13;
RDebugUtils.currentLine=3670038;
 //BA.debugLineNum = 3670038;BA.debugLine="lblBlue.Color = wTabColorON(wTune)			' Light C";
parent.mostCurrent._lblblue.setColor(parent._wtabcoloron[parent._wtune]);
RDebugUtils.currentLine=3670039;
 //BA.debugLineNum = 3670039;BA.debugLine="Sleep(wTimeWait)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,parent._wtimewait);
this.state = 20;
return;
case 20:
//C
this.state = 13;
;
RDebugUtils.currentLine=3670040;
 //BA.debugLineNum = 3670040;BA.debugLine="PlayTune(wTune)";
_playtune(parent._wtune);
RDebugUtils.currentLine=3670041;
 //BA.debugLineNum = 3670041;BA.debugLine="lblBlue.Color = wTabColorOFF(wTune)			' Dark C";
parent.mostCurrent._lblblue.setColor(parent._wtabcoloroff[parent._wtune]);
 if (true) break;

case 13:
//C
this.state = 16;
;
 if (true) break;
if (true) break;

case 14:
//C
this.state = -1;
;
RDebugUtils.currentLine=3670045;
 //BA.debugLineNum = 3670045;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static String  _playtune(int _tune) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "playtune"))
	return (String) Debug.delegate(mostCurrent.activityBA, "playtune", new Object[] {_tune});
RDebugUtils.currentLine=1638400;
 //BA.debugLineNum = 1638400;BA.debugLine="Sub PlayTune(Tune As Int)";
RDebugUtils.currentLine=1638401;
 //BA.debugLineNum = 1638401;BA.debugLine="wBeeper.Initialize(300, 500 + (Tune * 100))";
mostCurrent._wbeeper.Initialize((int) (300),(int) (500+(_tune*100)));
RDebugUtils.currentLine=1638402;
 //BA.debugLineNum = 1638402;BA.debugLine="wBeeper.Beep";
mostCurrent._wbeeper.Beep();
RDebugUtils.currentLine=1638403;
 //BA.debugLineNum = 1638403;BA.debugLine="End Sub";
return "";
}
public static String  _btnstart_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "btnstart_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "btnstart_click", null);
RDebugUtils.currentLine=1048576;
 //BA.debugLineNum = 1048576;BA.debugLine="Sub btnStart_Click";
RDebugUtils.currentLine=1048577;
 //BA.debugLineNum = 1048577;BA.debugLine="GameReset";
_gamereset();
RDebugUtils.currentLine=1048578;
 //BA.debugLineNum = 1048578;BA.debugLine="GetNewKey";
_getnewkey();
RDebugUtils.currentLine=1048579;
 //BA.debugLineNum = 1048579;BA.debugLine="APPplayTunes";
_appplaytunes();
RDebugUtils.currentLine=1048580;
 //BA.debugLineNum = 1048580;BA.debugLine="End Sub";
return "";
}
public static String  _gamereset() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gamereset"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gamereset", null);
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub GameReset";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="wIndex = -1";
_windex = (int) (-1);
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="wCtError = 0";
_wcterror = (int) (0);
RDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="lblYellow.Enabled = True";
mostCurrent._lblyellow.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="lblGreen.Enabled = True";
mostCurrent._lblgreen.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=458757;
 //BA.debugLineNum = 458757;BA.debugLine="lblRed.Enabled = True";
mostCurrent._lblred.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=458758;
 //BA.debugLineNum = 458758;BA.debugLine="lblBlue.Enabled = True";
mostCurrent._lblblue.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=458759;
 //BA.debugLineNum = 458759;BA.debugLine="btnStart.visible = False";
mostCurrent._btnstart.setVisible(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=458760;
 //BA.debugLineNum = 458760;BA.debugLine="End Sub";
return "";
}
public static String  _getnewkey() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "getnewkey"))
	return (String) Debug.delegate(mostCurrent.activityBA, "getnewkey", null);
RDebugUtils.currentLine=3604480;
 //BA.debugLineNum = 3604480;BA.debugLine="Sub GetNewKey";
RDebugUtils.currentLine=3604481;
 //BA.debugLineNum = 3604481;BA.debugLine="wIndex = wIndex + 1";
_windex = (int) (_windex+1);
RDebugUtils.currentLine=3604482;
 //BA.debugLineNum = 3604482;BA.debugLine="wTunesApp(wIndex) = Rnd(0, 4)			' NumberFormat2(R";
_wtunesapp[_windex] = anywheresoftware.b4a.keywords.Common.Rnd((int) (0),(int) (4));
RDebugUtils.currentLine=3604483;
 //BA.debugLineNum = 3604483;BA.debugLine="Log(\"GetNewKey: Index '\" & wIndex & \"' - New key";
anywheresoftware.b4a.keywords.Common.Log("GetNewKey: Index '"+BA.NumberToString(_windex)+"' - New key '"+BA.NumberToString(_wtunesapp[_windex])+"'");
RDebugUtils.currentLine=3604485;
 //BA.debugLineNum = 3604485;BA.debugLine="End Sub";
return "";
}
public static String  _gameover() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "gameover"))
	return (String) Debug.delegate(mostCurrent.activityBA, "gameover", null);
RDebugUtils.currentLine=2162688;
 //BA.debugLineNum = 2162688;BA.debugLine="Sub GameOver";
RDebugUtils.currentLine=2162689;
 //BA.debugLineNum = 2162689;BA.debugLine="lblYellow.Enabled = False";
mostCurrent._lblyellow.setEnabled(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=2162690;
 //BA.debugLineNum = 2162690;BA.debugLine="lblGreen.Enabled = False";
mostCurrent._lblgreen.setEnabled(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=2162691;
 //BA.debugLineNum = 2162691;BA.debugLine="lblRed.Enabled = False";
mostCurrent._lblred.setEnabled(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=2162692;
 //BA.debugLineNum = 2162692;BA.debugLine="lblBlue.Enabled = False";
mostCurrent._lblblue.setEnabled(anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=2162693;
 //BA.debugLineNum = 2162693;BA.debugLine="btnStart.visible = True";
mostCurrent._btnstart.setVisible(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=2162694;
 //BA.debugLineNum = 2162694;BA.debugLine="End Sub";
return "";
}
public static String  _lblbutton_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "lblbutton_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "lblbutton_click", null);
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub lblButton_Click";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="wKey = Sender";
mostCurrent._wkey.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="Log(\"lblButton_Click: Tecla User \" & wKey.tag)";
anywheresoftware.b4a.keywords.Common.Log("lblButton_Click: Tecla User "+BA.ObjectToString(mostCurrent._wkey.getTag()));
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="wKey.Color = wTabColorON(wKey.Tag)		' Light Color";
mostCurrent._wkey.setColor(_wtabcoloron[(int)(BA.ObjectToNumber(mostCurrent._wkey.getTag()))]);
RDebugUtils.currentLine=327684;
 //BA.debugLineNum = 327684;BA.debugLine="PlayTune(wKey.Tag)";
_playtune((int)(BA.ObjectToNumber(mostCurrent._wkey.getTag())));
RDebugUtils.currentLine=327685;
 //BA.debugLineNum = 327685;BA.debugLine="wKey.Color = wTabColorOFF(wKey.Tag)		' Dark Color";
mostCurrent._wkey.setColor(_wtabcoloroff[(int)(BA.ObjectToNumber(mostCurrent._wkey.getTag()))]);
RDebugUtils.currentLine=327687;
 //BA.debugLineNum = 327687;BA.debugLine="If wKey.Tag = wTunesApp(wIndex) Then";
if ((mostCurrent._wkey.getTag()).equals((Object)(_wtunesapp[_windex]))) { 
RDebugUtils.currentLine=327688;
 //BA.debugLineNum = 327688;BA.debugLine="Log(\"Clicou Certo\")";
anywheresoftware.b4a.keywords.Common.Log("Clicou Certo");
RDebugUtils.currentLine=327689;
 //BA.debugLineNum = 327689;BA.debugLine="GetNewKey";
_getnewkey();
RDebugUtils.currentLine=327690;
 //BA.debugLineNum = 327690;BA.debugLine="APPplayTunes";
_appplaytunes();
 }else {
RDebugUtils.currentLine=327692;
 //BA.debugLineNum = 327692;BA.debugLine="Log(\"lblButton_Click: \" & wIndex & \") Clicou Err";
anywheresoftware.b4a.keywords.Common.Log("lblButton_Click: "+BA.NumberToString(_windex)+") Clicou Errado: "+BA.ObjectToString(mostCurrent._wkey.getTag())+" deveria ser "+BA.NumberToString(_wtunesapp[_windex]));
RDebugUtils.currentLine=327693;
 //BA.debugLineNum = 327693;BA.debugLine="wCtError = wCtError + 1";
_wcterror = (int) (_wcterror+1);
RDebugUtils.currentLine=327694;
 //BA.debugLineNum = 327694;BA.debugLine="If wCtError > 3 Then";
if (_wcterror>3) { 
RDebugUtils.currentLine=327695;
 //BA.debugLineNum = 327695;BA.debugLine="Msgbox(\"You missed 3 tunes\", \"Game Over\")";
anywheresoftware.b4a.keywords.Common.Msgbox(BA.ObjectToCharSequence("You missed 3 tunes"),BA.ObjectToCharSequence("Game Over"),mostCurrent.activityBA);
RDebugUtils.currentLine=327696;
 //BA.debugLineNum = 327696;BA.debugLine="GameOver";
_gameover();
 }else {
RDebugUtils.currentLine=327698;
 //BA.debugLineNum = 327698;BA.debugLine="Msgbox(\"Wrong Key sequence\", \"Try Again\")";
anywheresoftware.b4a.keywords.Common.Msgbox(BA.ObjectToCharSequence("Wrong Key sequence"),BA.ObjectToCharSequence("Try Again"),mostCurrent.activityBA);
RDebugUtils.currentLine=327699;
 //BA.debugLineNum = 327699;BA.debugLine="APPplayTunes";
_appplaytunes();
 };
 };
RDebugUtils.currentLine=327702;
 //BA.debugLineNum = 327702;BA.debugLine="End Sub";
return "";
}
}